//# version.h: Version information for PlotMS
//# Copyright (C) 2022
//# Associated Universities, Inc. Washington DC, USA.
//#
//# This library is free software; you can redistribute it and/or modify it
//# under the terms of the GNU Library General Public License as published by
//# the Free Software Foundation; either version 2 of the License, or (at your
//# option) any later version.
//#
//# This library is distributed in the hope that it will be useful, but WITHOUT
//# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
//# FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
//# License for more details.
//#
//# You should have received a copy of the GNU Library General Public License
//# along with this library; if not, write to the Free Software Foundation,
//# Inc., 675 Massachusetts Ave, Cambridge, MA 02139, USA.
//#
//# Correspondence concerning AIPS++ should be addressed as follows:
//#        Internet email: casa-feedback@nrao.edu.
//#        Postal address: AIPS++ Project Office
//#                        National Radio Astronomy Observatory
//#                        520 Edgemont Road
//#                        Charlottesville, VA 22903-2475 USA
//#
//#
//# $Id$

#ifndef CASA_PLOTMS_VERSION_H
#define CASA_PLOTMS_VERSION_H

//# Includes
#include <iostream>
#include <vector>

namespace casa { //# NAMESPACE CASA - BEGIN

class PlotMSVersionInfo {
    public:

    static std::string branch_tag( ); // branch tag version, e.g. CAS-13724-1
    static std::string master_tag( ); // master tag version branched from: e.g. 1.4.0
    static std::string info( );       // combined string: e.g. "CAS-13724-1 1.4.0"

    // Summarize the above into an ostream. Note that an
    // <src>ostringstream</src> can be converted to a
    // <linkto class="String">String</linkto> via a constructor.
    // This information is NOT prepended with "PlotMS version:" or anything
    // like that. You may wish to add this yourself. The date is also not
    // included.
    static void report(std::ostream &os) { os << info( ); }

};

} //# NAMESPACE CASA - END

#endif
